diff --git a/testing/mozharness/mozharness/base/python.py b/testing/mozharness/mozharness/base/python.py
index cb5bfbc46c..b13df1fa74 100644
--- a/testing/mozharness/mozharness/base/python.py
+++ b/testing/mozharness/mozharness/base/python.py
@@ -14,7 +14,7 @@ import sys
 import json
 import socket
 import traceback
-import urlparse
+import six.moves.urllib.parse
 
 import mozharness
 from mozharness.base.script import (
@@ -26,6 +26,7 @@ from mozharness.base.script import (
 from mozharness.base.errors import VirtualenvErrorList
 from mozharness.base.log import WARNING, FATAL
 from mozharness.mozilla.proxxy import Proxxy
+import six
 
 external_tools_path = os.path.join(
     os.path.abspath(os.path.dirname(os.path.dirname(mozharness.__file__))),
@@ -162,7 +163,7 @@ class VirtualenvMixin(object):
                 self.log("package_versions: Program pip not in path", level=error_level)
                 return {}
             pip_freeze_output = self.get_output_from_command([pip, "freeze"], silent=True, ignore_errors=True)
-            if not isinstance(pip_freeze_output, basestring):
+            if not isinstance(pip_freeze_output, str):
                 self.fatal("package_versions: Error encountered running `pip freeze`: %s" % pip_freeze_output)
 
         for line in pip_freeze_output.splitlines():
@@ -190,7 +191,7 @@ class VirtualenvMixin(object):
         """
         Return whether the package is installed
         """
-        packages = self.package_versions(error_level=error_level).keys()
+        packages = list(self.package_versions(error_level=error_level).keys())
         return package_name.lower() in [package.lower() for package in packages]
 
     def install_module(self, module=None, module_url=None, install_method=None,
@@ -255,7 +256,7 @@ class VirtualenvMixin(object):
         proxxy = Proxxy(self.config, self.log_obj)
         trusted_hosts = set()
         for link in proxxy.get_proxies_and_urls(c.get('find_links', [])):
-            parsed = urlparse.urlparse(link)
+            parsed = six.moves.urllib.parse.urlparse(link)
 
             try:
                 socket.gethostbyname(parsed.hostname)
@@ -434,7 +435,7 @@ class VirtualenvMixin(object):
         """Import the virtualenv's packages into this Python interpreter."""
         bin_dir = os.path.dirname(self.query_python_path())
         activate = os.path.join(bin_dir, 'activate_this.py')
-        execfile(activate, dict(__file__=activate))
+        exec(compile(open(activate, "rb").read(), activate, 'exec'), dict(__file__=activate))
 
 
 # This is (sadly) a mixin for logging methods.
diff --git a/testing/mozharness/mozharness/base/script.py b/testing/mozharness/mozharness/base/script.py
index 828f4e39e8..e3b56524ac 100755
--- a/testing/mozharness/mozharness/base/script.py
+++ b/testing/mozharness/mozharness/base/script.py
@@ -11,6 +11,7 @@ script.py, along with config.py and log.py, represents the core of
 mozharness.
 """
 
+from __future__ import print_function
 import codecs
 from contextlib import contextmanager
 import datetime
@@ -31,11 +32,12 @@ import sys
 import tarfile
 import time
 import traceback
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 import zipfile
-import httplib
-import urlparse
+import six.moves.http_client
+import six.moves.urllib.parse
 import hashlib
+import six
 if os.name == 'nt':
     try:
         import win32file
@@ -246,7 +248,7 @@ class ScriptMixin(PlatformMixin):
             str: in case `path` is a string. The result is the path with the new notation.
             type(path): `path` itself is returned in case `path` is not str type.
         """
-        if not isinstance(path, basestring):
+        if not isinstance(path, str):
             return path
         path = path.replace("\\", "/")
 
@@ -316,7 +318,7 @@ class ScriptMixin(PlatformMixin):
                  of the url.
         """
 
-        parsed = urlparse.urlsplit(url.rstrip('/'))
+        parsed = six.moves.urllib.parse.urlsplit(url.rstrip('/'))
         if parsed.path != '':
             return parsed.path.rsplit('/', 1)[-1]
         else:
@@ -342,8 +344,8 @@ class ScriptMixin(PlatformMixin):
         https://docs.python.org/2/library/urllib2.html#urllib2.urlopen
         """
         # http://bugs.python.org/issue13359 - urllib2 does not automatically quote the URL
-        url_quoted = urllib2.quote(url, safe='%/:=&?~#+!$,;\'@()*[]|')
-        return urllib2.urlopen(url_quoted, **kwargs)
+        url_quoted = six.moves.urllib.parse.quote(url, safe='%/:=&?~#+!$,;\'@()*[]|')
+        return six.moves.urllib.request.urlopen(url_quoted, **kwargs)
 
 
 
@@ -363,7 +365,7 @@ class ScriptMixin(PlatformMixin):
             BytesIO: contents of url
         '''
         self.info('Fetch {} into memory'.format(url))
-        parsed_url = urlparse.urlparse(url)
+        parsed_url = six.moves.urllib.parse.urlparse(url)
 
         if parsed_url.scheme in ('', 'file'):
             if not os.path.isfile(url):
@@ -374,9 +376,9 @@ class ScriptMixin(PlatformMixin):
             # In case we're referrencing a file without file://
             if parsed_url.scheme == '':
                 url = 'file://%s' % os.path.abspath(url)
-                parsed_url = urlparse.urlparse(url)
+                parsed_url = six.moves.urllib.parse.urlparse(url)
 
-        request = urllib2.Request(url)
+        request = six.moves.urllib.request.Request(url)
         # When calling fetch_url_into_memory() you should retry when we raise one of these exceptions:
         # * Bug 1300663 - HTTPError: HTTP Error 404: Not Found
         # * Bug 1300413 - HTTPError: HTTP Error 500: Internal Server Error
@@ -389,7 +391,7 @@ class ScriptMixin(PlatformMixin):
         # * Bug 1301807 - BadStatusLine: ''
         #
         # Bug 1309912 - Adding timeout in hopes to solve blocking on response.read() (bug 1300413)
-        response = urllib2.urlopen(request, timeout=30)
+        response = six.moves.urllib.request.urlopen(request, timeout=30)
 
         if parsed_url.scheme in ('http', 'https'):
             expected_file_size = int(response.headers.get('Content-Length'))
@@ -453,17 +455,17 @@ class ScriptMixin(PlatformMixin):
                 block = f.read(1024 ** 2)
                 if not block:
                     if f_length is not None and got_length != f_length:
-                        raise urllib2.URLError("Download incomplete; content-length was %d, but only received %d" % (f_length, got_length))
+                        raise six.moves.urllib.error.URLError("Download incomplete; content-length was %d, but only received %d" % (f_length, got_length))
                     break
                 local_file.write(block)
                 if f_length is not None:
                     got_length += len(block)
             local_file.close()
             return file_name
-        except urllib2.HTTPError, e:
+        except six.moves.urllib.error.HTTPError as e:
             self.warning("Server returned status %s %s for %s" % (str(e.code), str(e), url))
             raise
-        except urllib2.URLError, e:
+        except six.moves.urllib.error.URLError as e:
             self.warning("URL Error: %s" % url)
 
             # Failures due to missing local files won't benefit from retry.
@@ -471,7 +473,7 @@ class ScriptMixin(PlatformMixin):
             if isinstance(e.args[0], OSError) and e.args[0].errno == errno.ENOENT:
                 raise e.args[0]
 
-            remote_host = urlparse.urlsplit(url)[1]
+            remote_host = six.moves.urllib.parse.urlsplit(url)[1]
             if remote_host:
                 nslookup = self.query_exe('nslookup')
                 error_list = [{
@@ -482,10 +484,10 @@ class ScriptMixin(PlatformMixin):
                 self.run_command([nslookup, remote_host],
                                  error_list=error_list)
             raise
-        except socket.timeout, e:
+        except socket.timeout as e:
             self.warning("Timed out accessing %s: %s" % (url, str(e)))
             raise
-        except socket.error, e:
+        except socket.error as e:
             self.warning("Socket error when accessing %s: %s" % (url, str(e)))
             raise
 
@@ -511,8 +513,8 @@ class ScriptMixin(PlatformMixin):
         """
         retry_args = dict(
             failure_status=None,
-            retry_exceptions=(urllib2.HTTPError, urllib2.URLError,
-                              httplib.BadStatusLine,
+            retry_exceptions=(six.moves.urllib.error.HTTPError, six.moves.urllib.error.URLError,
+                              six.moves.http_client.BadStatusLine,
                               socket.timeout, socket.error),
             error_message="Can't download from %s to %s!" % (url, file_name),
             error_level=error_level,
@@ -537,7 +539,7 @@ class ScriptMixin(PlatformMixin):
     def _filter_entries(self, namelist, extract_dirs):
         """Filter entries of the archive based on the specified list of to extract dirs."""
         filter_partial = functools.partial(fnmatch.filter, namelist)
-        entries = itertools.chain(*map(filter_partial, extract_dirs or ['*']))
+        entries = itertools.chain(*list(map(filter_partial, extract_dirs or ['*'])))
 
         for entry in entries:
             yield entry
@@ -666,9 +668,9 @@ class ScriptMixin(PlatformMixin):
         # 1) Let's fetch the file
         retry_args = dict(
             retry_exceptions=(
-                urllib2.HTTPError,
-                urllib2.URLError,
-                httplib.BadStatusLine,
+                six.moves.urllib.error.HTTPError,
+                six.moves.urllib.error.URLError,
+                six.moves.http_client.BadStatusLine,
                 socket.timeout,
                 socket.error,
                 FetchedIncorrectFilesize,
@@ -768,11 +770,11 @@ class ScriptMixin(PlatformMixin):
         try:
             shutil.move(src, dest)
         # http://docs.python.org/tutorial/errors.html
-        except IOError, e:
+        except IOError as e:
             self.log("IO error: %s" % str(e),
                      level=error_level, exit_code=exit_code)
             return -1
-        except shutil.Error, e:
+        except shutil.Error as e:
             self.log("shutil error: %s" % str(e),
                      level=error_level, exit_code=exit_code)
             return -1
@@ -819,7 +821,7 @@ class ScriptMixin(PlatformMixin):
                 outfile.writelines(infile)
                 outfile.close()
                 infile.close()
-            except IOError, e:
+            except IOError as e:
                 self.log("Can't compress %s to %s: %s!" % (src, dest, str(e)),
                          level=error_level)
                 return -1
@@ -827,7 +829,7 @@ class ScriptMixin(PlatformMixin):
             self.log("Copying %s to %s" % (src, dest), level=log_level)
             try:
                 shutil.copyfile(src, dest)
-            except (IOError, shutil.Error), e:
+            except (IOError, shutil.Error) as e:
                 self.log("Can't copy %s to %s: %s!" % (src, dest, str(e)),
                          level=error_level)
                 return -1
@@ -835,7 +837,7 @@ class ScriptMixin(PlatformMixin):
         if copystat:
             try:
                 shutil.copystat(src, dest)
-            except (IOError, shutil.Error), e:
+            except (IOError, shutil.Error) as e:
                 self.log("Can't copy attributes of %s to %s: %s!" % (src, dest, str(e)),
                          level=error_level)
                 return -1
@@ -968,7 +970,7 @@ class ScriptMixin(PlatformMixin):
         self.info("Reading from file %s" % file_path)
         try:
             fh = open(file_path, open_mode)
-        except IOError, err:
+        except IOError as err:
             self.log("unable to open %s: %s" % (file_path, err.strerror),
                      level=error_level)
             yield None, err
@@ -1111,7 +1113,7 @@ class ScriptMixin(PlatformMixin):
                 status = action(*args, **kwargs)
                 if good_statuses and status not in good_statuses:
                     retry = True
-            except retry_exceptions, e:
+            except retry_exceptions as e:
                 retry = True
                 error_message = "%s\nCaught exception: %s" % (error_message, str(e))
                 self.log('retry: attempt #%d caught exception: %s' % (n, str(e)), level=INFO)
@@ -1232,7 +1234,7 @@ class ScriptMixin(PlatformMixin):
         if isinstance(exe, dict):
             found = False
             # allow for searchable paths of the buildbot exe
-            for name, path in exe.iteritems():
+            for name, path in exe.items():
                 if isinstance(path, list) or isinstance(path, tuple):
                     path = [x % repl_dict for x in path]
                     if all([os.path.exists(section) for section in path]):
@@ -1390,7 +1392,7 @@ class ScriptMixin(PlatformMixin):
                             break
                         parser.add_lines(line)
                 returncode = p.returncode
-        except OSError, e:
+        except OSError as e:
             level = error_level
             if halt_on_failure:
                 level = FATAL
@@ -2149,7 +2151,7 @@ class BaseScript(ScriptMixin, LogMixin, object):
                 except ValueError:
                     """log is closed; print as a default. Ran into this
                     when calling from __del__()"""
-                    print "### Log is closed! (%s)" % item['message']
+                    print("### Log is closed! (%s)" % item['message'])
 
     def add_summary(self, message, level=INFO):
         self.summary_list.append({'message': message, 'level': level})
diff --git a/testing/mozharness/mozharness/base/transfer.py b/testing/mozharness/mozharness/base/transfer.py
index 014c665a14..a298abfdab 100755
--- a/testing/mozharness/mozharness/base/transfer.py
+++ b/testing/mozharness/mozharness/base/transfer.py
@@ -9,7 +9,7 @@
 
 import os
 import pprint
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 try:
     import simplejson as json
     assert json
@@ -114,7 +114,7 @@ class TransferMixin(object):
         self.log("Attempting to download %s; timeout=%i" % (url, timeout),
                  level=log_level)
         try:
-            r = urllib2.urlopen(url, timeout=timeout)
+            r = six.moves.urllib.request.urlopen(url, timeout=timeout)
             j = json.load(r)
             self.log(pprint.pformat(j), level=log_level)
         except:
diff --git a/testing/mozharness/mozharness/base/vcs/gittool.py b/testing/mozharness/mozharness/base/vcs/gittool.py
index d6c609ea02..b835bacb94 100644
--- a/testing/mozharness/mozharness/base/vcs/gittool.py
+++ b/testing/mozharness/mozharness/base/vcs/gittool.py
@@ -1,6 +1,6 @@
 import os
 import re
-import urlparse
+import six.moves.urllib.parse
 
 from mozharness.base.script import ScriptMixin
 from mozharness.base.log import LogMixin, OutputParser
@@ -80,8 +80,8 @@ class GittoolVCS(ScriptMixin, LogMixin):
             cmd.append('--clean')
 
         for base_mirror_url in self.config.get('gittool_base_mirror_urls', self.config.get('vcs_base_mirror_urls', [])):
-            bits = urlparse.urlparse(repo)
-            mirror_url = urlparse.urljoin(base_mirror_url, bits.path)
+            bits = six.moves.urllib.parse.urlparse(repo)
+            mirror_url = six.moves.urllib.parse.urljoin(base_mirror_url, bits.path)
             cmd.extend(['--mirror', mirror_url])
 
         cmd.extend([repo, dest])
diff --git a/testing/mozharness/mozharness/base/vcs/mercurial.py b/testing/mozharness/mozharness/base/vcs/mercurial.py
index 71e5e3ea03..e89b1643b8 100755
--- a/testing/mozharness/mozharness/base/vcs/mercurial.py
+++ b/testing/mozharness/mozharness/base/vcs/mercurial.py
@@ -11,7 +11,7 @@ import os
 import re
 import subprocess
 from collections import namedtuple
-from urlparse import urlsplit
+from urllib.parse import urlsplit
 import hashlib
 
 import sys
@@ -299,7 +299,7 @@ class MercurialVCS(ScriptMixin, LogMixin, TransferMixin):
                         branch = "default"
                     revs.append((rev, branch))
                 return revs
-            except subprocess.CalledProcessError, inst:
+            except subprocess.CalledProcessError as inst:
                 # In some situations, some versions of Mercurial return "1"
                 # if no changes are found, so we need to ignore this return
                 # code
@@ -419,7 +419,7 @@ class MercurialVCS(ScriptMixin, LogMixin, TransferMixin):
                           ssh_username=ssh_username,
                           ssh_key=ssh_key)
                 return
-            except VCSException, e:
+            except VCSException as e:
                 self.debug("Hit error when trying to push: %s" % str(e))
                 if n == max_attempts:
                     self.debug("Tried %d times, giving up" % max_attempts)
@@ -435,7 +435,7 @@ class MercurialVCS(ScriptMixin, LogMixin, TransferMixin):
                     self.run_command(self.hg + ['rebase'], cwd=localrepo,
                                      error_list=HgErrorList,
                                      throw_exception=True)
-                except subprocess.CalledProcessError, e:
+                except subprocess.CalledProcessError as e:
                     self.debug("Failed to rebase: %s" % str(e))
                     # clean up any hanging rebase. ignore errors if we aren't
                     # in the middle of a rebase.
@@ -481,7 +481,7 @@ class MercurialVCS(ScriptMixin, LogMixin, TransferMixin):
             #
             # So we grab the first element ("28537" in this case) and then pull
             # out the 'date' field.
-            pushid = contents.iterkeys().next()
+            pushid = next(contents.keys())
             self.info('Pushid is: %s' % pushid)
             pushdate = contents[pushid]['date']
             self.info('Pushdate is: %s' % pushdate)
diff --git a/testing/mozharness/mozharness/lib/python/authentication.py b/testing/mozharness/mozharness/lib/python/authentication.py
index 2e5f83f373..6944d2321b 100644
--- a/testing/mozharness/mozharness/lib/python/authentication.py
+++ b/testing/mozharness/mozharness/lib/python/authentication.py
@@ -5,6 +5,7 @@
 # ***** END LICENSE BLOCK *****
 
 """module for http authentication operations"""
+from __future__ import print_function
 import getpass
 import os
 
@@ -33,15 +34,15 @@ def get_credentials():
             os.remove(CREDENTIALS_PATH)
     else:
         https_username = \
-                raw_input("Please enter your full LDAP email address: ")
+                input("Please enter your full LDAP email address: ")
 
         with open(CREDENTIALS_PATH, "w+") as file_handler:
             file_handler.write("%s\n" % https_username)
 
-        os.chmod(CREDENTIALS_PATH, 0600)
+        os.chmod(CREDENTIALS_PATH, 0o600)
 
     if not LDAP_PASSWORD:
-        print "Please enter your LDAP password (we won't store it):"
+        print("Please enter your LDAP password (we won't store it):")
         LDAP_PASSWORD = getpass.getpass()
 
     return https_username, LDAP_PASSWORD
diff --git a/testing/mozharness/mozharness/mozilla/bouncer/submitter.py b/testing/mozharness/mozharness/mozilla/bouncer/submitter.py
index 43983dca8d..7c92671eb1 100644
--- a/testing/mozharness/mozharness/mozilla/bouncer/submitter.py
+++ b/testing/mozharness/mozharness/mozilla/bouncer/submitter.py
@@ -1,10 +1,10 @@
 import base64
-import httplib
+import six.moves.http_client
 import socket
 import sys
 import traceback
-import urllib
-import urllib2
+import six.moves.urllib.request, six.moves.urllib.parse, six.moves.urllib.error
+import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 from xml.dom.minidom import parseString
 
 from mozharness.base.log import FATAL
@@ -16,7 +16,7 @@ class BouncerSubmitterMixin(object):
             return self.credentials
         global_dict = {}
         local_dict = {}
-        execfile(self.config["credentials_file"], global_dict, local_dict)
+        exec(compile(open(self.config["credentials_file"], "rb").read(), self.config["credentials_file"], 'exec'), global_dict, local_dict)
         self.credentials = (local_dict["tuxedoUsername"],
                             local_dict["tuxedoPassword"])
         return self.credentials
@@ -24,8 +24,8 @@ class BouncerSubmitterMixin(object):
     def api_call(self, route, data, error_level=FATAL, retry_config=None):
         retry_args = dict(
             failure_status=None,
-            retry_exceptions=(urllib2.HTTPError, urllib2.URLError,
-                              httplib.BadStatusLine,
+            retry_exceptions=(six.moves.urllib.error.HTTPError, six.moves.urllib.error.URLError,
+                              six.moves.http_client.BadStatusLine,
                               socket.timeout, socket.error),
             error_message="call to %s failed" % (route),
             error_level=error_level,
@@ -43,9 +43,9 @@ class BouncerSubmitterMixin(object):
     def _api_call(self, route, data):
         api_prefix = self.config["bouncer-api-prefix"]
         api_url = "%s/%s" % (api_prefix, route)
-        request = urllib2.Request(api_url)
+        request = six.moves.urllib.request.Request(api_url)
         if data:
-            post_data = urllib.urlencode(data, doseq=True)
+            post_data = six.moves.urllib.parse.urlencode(data, doseq=True)
             request.add_data(post_data)
             self.info("POST data: %s" % post_data)
         credentials = self.query_credentials()
@@ -54,17 +54,17 @@ class BouncerSubmitterMixin(object):
             request.add_header("Authorization", "Basic %s" % auth.strip())
         try:
             self.info("Submitting to %s" % api_url)
-            res = urllib2.urlopen(request, timeout=60).read()
+            res = six.moves.urllib.request.urlopen(request, timeout=60).read()
             self.info("Server response")
             self.info(res)
             return res
-        except urllib2.HTTPError as e:
+        except six.moves.urllib.error.HTTPError as e:
             self.warning("Cannot access %s" % api_url)
             traceback.print_exc(file=sys.stdout)
             self.warning("Returned page source:")
             self.warning(e.read())
             raise
-        except urllib2.URLError:
+        except six.moves.urllib.error.URLError:
             traceback.print_exc(file=sys.stdout)
             self.warning("Cannot access %s" % api_url)
             raise
@@ -74,14 +74,14 @@ class BouncerSubmitterMixin(object):
         except socket.error as e:
             self.warning("Socket error when accessing %s: %s" % (api_url, e))
             raise
-        except httplib.BadStatusLine as e:
+        except six.moves.http_client.BadStatusLine as e:
             self.warning('BadStatusLine accessing %s: %s' % (api_url, e))
             raise
 
     def product_exists(self, product_name):
         self.info("Checking if %s already exists" % product_name)
         res = self.api_call("product_show?product=%s" %
-                            urllib.quote(product_name), data=None)
+                            six.moves.urllib.parse.quote(product_name), data=None)
         try:
             xml = parseString(res)
             # API returns <products/> if the product doesn't exist
diff --git a/testing/mozharness/mozharness/mozilla/buildbot.py b/testing/mozharness/mozharness/mozilla/buildbot.py
index e17343633b..78e34bf558 100755
--- a/testing/mozharness/mozharness/mozilla/buildbot.py
+++ b/testing/mozharness/mozharness/mozilla/buildbot.py
@@ -133,7 +133,7 @@ class BuildbotMixin(object):
         if not os.path.isdir(dir_name):
             self.mkdir_p(dir_name)
         if not prop_list:
-            prop_list = self.buildbot_properties.keys()
+            prop_list = list(self.buildbot_properties.keys())
             self.info("Writing buildbot properties to %s" % file_name)
         else:
             if not isinstance(prop_list, (list, tuple)):
@@ -171,7 +171,7 @@ class BuildbotMixin(object):
             if self.buildbot_config['sourcestamp']['changes'][0].get('comments'):
                 sendchange += ['--comments', self.buildbot_config['sourcestamp']['changes'][0]['comments'].encode('ascii', 'ignore')]
         if sendchange_props:
-            for key, value in sendchange_props.iteritems():
+            for key, value in sendchange_props.items():
                 sendchange.extend(['--property', '%s:%s' % (key, value)])
         else:
             if self.buildbot_config["properties"].get("builduid"):
diff --git a/testing/mozharness/mozharness/mozilla/building/buildbase.py b/testing/mozharness/mozharness/mozilla/building/buildbase.py
index 9fd507816d..b20e74298a 100755
--- a/testing/mozharness/mozharness/mozilla/building/buildbase.py
+++ b/testing/mozharness/mozharness/mozilla/building/buildbase.py
@@ -55,7 +55,7 @@ from mozharness.base.python import (
     VirtualenvMixin,
 )
 
-AUTOMATION_EXIT_CODES = EXIT_STATUS_DICT.values()
+AUTOMATION_EXIT_CODES = list(EXIT_STATUS_DICT.values())
 AUTOMATION_EXIT_CODES.sort()
 
 MISSING_CFG_KEY_MSG = "The key '%s' could not be determined \
@@ -466,7 +466,7 @@ class BuildOptionParser(object):
                      "shortname: %s \n\t-- a valid path in %s \n\t-- a "
                      "valid variant for the given platform and bits." % (
                          prospective_cfg_path,
-                         str(cls.build_variants.keys()),
+                         str(list(cls.build_variants.keys())),
                          str(cls.config_file_search_path)))
         parser.values.config_files.append(valid_variant_cfg_path)
         setattr(parser.values, option.dest, value)  # the pool
@@ -528,7 +528,7 @@ BUILD_BASE_CONFIG_OPTIONS = [
         "help": "Sets the build type and will determine appropriate"
                 " additional config to use. Either pass a config path"
                 " or use a valid shortname from: "
-                "%s" % (BuildOptionParser.build_variants.keys(),)}],
+                "%s" % (list(BuildOptionParser.build_variants.keys()),)}],
     [['--build-pool'], {
         "action": "callback",
         "callback": BuildOptionParser.set_build_pool,
@@ -676,7 +676,7 @@ platform '%(platform)s'. Updating self.config with the following from \
                     }
                 )
         if c.get("platform_overrides"):
-            if c['stage_platform'] in c['platform_overrides'].keys():
+            if c['stage_platform'] in list(c['platform_overrides'].keys()):
                 self.info(
                     pf_override_msg % {
                         'branch': c['branch'],
@@ -960,7 +960,7 @@ or run without that action (ie: --no-{action})"
         dirs = self.query_abs_dirs()
         check_test_env = {}
         if c.get('check_test_env'):
-            for env_var, env_value in c['check_test_env'].iteritems():
+            for env_var, env_value in c['check_test_env'].items():
                 check_test_env[env_var] = env_value % dirs
         return check_test_env
 
@@ -1224,8 +1224,8 @@ or run without that action (ie: --no-{action})"
         # persisted to file rather than use whats in the buildbot_properties
         # live object so we become less action dependant.
         all_current_props = dict(
-            chain(self.buildbot_config['properties'].items(),
-                  self.buildbot_properties.items())
+            chain(list(self.buildbot_config['properties'].items()),
+                  list(self.buildbot_properties.items()))
         )
         # graph_server_post.py expects a file with 'properties' key
         graph_props = dict(properties=all_current_props)
@@ -1250,7 +1250,7 @@ or run without that action (ie: --no-{action})"
                 if console_output:
                     self.info("Properties set from 'mach build'")
                     self.info(pprint.pformat(build_props))
-            for key, prop in build_props.iteritems():
+            for key, prop in build_props.items():
                 if prop != 'UNKNOWN':
                     self.set_buildbot_property(key, prop, write_to_file=True)
         else:
@@ -1341,7 +1341,7 @@ or run without that action (ie: --no-{action})"
         dirs = self.query_abs_dirs()
         auth = os.path.join(os.getcwd(), self.config['taskcluster_credentials_file'])
         credentials = {}
-        execfile(auth, credentials)
+        exec(compile(open(auth, "rb").read(), auth, 'exec'), credentials)
         self.client_id = credentials.get('taskcluster_clientId')
         self.access_token = credentials.get('taskcluster_accessToken')
 
@@ -2147,7 +2147,7 @@ or run without that action (ie: --no-{action})"
                            "Valid return codes %s" % (self.return_code,
                                                       AUTOMATION_EXIT_CODES))
                 self.return_code = 2
-            for status, return_code in EXIT_STATUS_DICT.iteritems():
+            for status, return_code in EXIT_STATUS_DICT.items():
                 if return_code == self.return_code:
                     self.buildbot_status(status, TBPL_STATUS_DICT[status])
         self.summary()
diff --git a/testing/mozharness/mozharness/mozilla/building/hazards.py b/testing/mozharness/mozharness/mozilla/building/hazards.py
index 6de235f892..3653c165ba 100644
--- a/testing/mozharness/mozharness/mozilla/building/hazards.py
+++ b/testing/mozharness/mozharness/mozilla/building/hazards.py
@@ -1,3 +1,4 @@
+from __future__ import print_function
 import os
 import json
 import re
@@ -104,7 +105,7 @@ jobs = 4
 """ % values
 
         defaults_path = os.path.join(analysis_dir, 'defaults.py')
-        file(defaults_path, "w").write(defaults)
+        open(defaults_path, "w").write(defaults)
         builder.log("Wrote analysis config file " + defaults_path)
 
         build_script = builder.config['build_command']
@@ -165,14 +166,14 @@ jobs = 4
                  ('hazards.txt',
                   'hazards',
                   'list of just the hazards, together with gcFunction reason for each'))
-        for f, short, long in files:
+        for f, short, int in files:
             builder.copy_to_upload_dir(os.path.join(analysis_dir, f),
                                        short_desc=short,
-                                       long_desc=long,
+                                       long_desc=int,
                                        compress=False,  # blobber will compress
                                        upload_dir=upload_dir)
         print("== Hazards (temporarily inline here, beware weirdly interleaved output, see bug 1211402) ==")
-        print(file(os.path.join(analysis_dir, "hazards.txt")).read())
+        print((open(os.path.join(analysis_dir, "hazards.txt")).read()))
 
     def upload_results(self, builder):
         """Upload the results of the analysis."""
diff --git a/testing/mozharness/mozharness/mozilla/l10n/locales.py b/testing/mozharness/mozharness/mozilla/l10n/locales.py
index 24920ae445..f6fad57aa3 100755
--- a/testing/mozharness/mozharness/mozilla/l10n/locales.py
+++ b/testing/mozharness/mozharness/mozilla/l10n/locales.py
@@ -8,7 +8,7 @@
 """
 
 import os
-from urlparse import urljoin
+from urllib.parse import urljoin
 import sys
 from copy import deepcopy
 
